import SwiftUI

struct DetailView: View {
    @State var todo: Todo
    var onSave: (Todo) -> ()

    private func SectionTitle(_ title: String) -> some View {
        Text(title).font(.headline)
    }

    var body: some View {
        VStack(alignment: .leading) {
            SectionTitle("タイトル")
            TextField("やろうとしていること", text: $todo.title)
                .font(.title).padding()
            SectionTitle("期限")
            DatePicker("", selection: $todo.dueDate, displayedComponents: [.date])
            Spacer()
        }
            .padding()
            .onDisappear {
                self.onSave(self.todo)
            }
    }
}

struct DetailView_Previews: PreviewProvider {
    static var previews: some View {
        DetailView(todo: Todo()) { _ in }
    }
}
