import SwiftUI

struct ListView: View {
    @EnvironmentObject var todoData: TodoData
    @State var editing: Todo?

    var body: some View {
        List(todoData.todos) { todo in
            Button(action: { self.editing = todo }) {
                TodoCard(todo: todo)
            }
        }
            .navigationBarTitle("Todoリスト")
            .navigationBarItems(trailing:
                Button(action: { self.editing = Todo() }) {
                    Text("追加")
                    Image(systemName: "plus.circle")
                }
            )
            .sheet(item: $editing) { todo in
                DetailView(todo: todo, onSave: { todo in
                    self.todoData.store(todo: todo)
                })
            }
    }
}

struct ListView_Previews: PreviewProvider {
    static var previews: some View {
        NavigationView {
            ListView()
                .environmentObject(TodoData())
        }
    }
}
